//
//  STLayerObject.h
//  Coda
//
//  Created by Davyd Geyl on 14/11/07.
//  Copyright 2007 Sportstec Ltd. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@protocol STLayerObject

- (id<STLayerObject>)queryInterface:(Protocol*)interface;
- (BOOL)didReturnDifferentValues;

@end

@interface NSObject(STLayerObject)

- (id<STLayerObject>)queryInterface:(Protocol*)interface;
- (BOOL)didReturnDifferentValues;

@end

@interface STLayerObject : NSProxy <STLayerObject>

@property (nonatomic, strong) NSArray *array;
@property (nonatomic, assign) BOOL didReturnDifferentValues;

- (instancetype)initWithObjectArray:(NSArray*)array;
- (id<STLayerObject>)queryInterface:(Protocol*)interface;
- (BOOL)didReturnDifferentValues;

- (NSEnumerator *)objectEnumerator;

@end
