//
//  STPoint.h
//  Kahuna
//  Custom Point Class as a wrapper for NSPoint etc.
//
//  Created by Boris Miller on 2/09/09.
//  Copyright 2009 Sportstec Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface STPoint : NSObject <NSCoding>

+ (instancetype)valueWithPoint:(CGPoint)point;
+ (instancetype)pointWithCGPoint:(CGPoint)point;
+ (instancetype)pointWithX:(CGFloat)x withY:(CGFloat)y;

+ (NSArray*)STpointsFromNSValuePoints:(NSArray*)points;
+ (NSArray*)NSValuePointsFromSTPoints:(NSArray*)points;

@property (nonatomic, assign) CGFloat x;
@property (nonatomic, assign) CGFloat y;

- (instancetype)initWithX:(CGFloat)x withY:(CGFloat)y;
- (instancetype)initWithCGPoint:(CGPoint)point;
- (instancetype)initWithNSPoint:(NSPoint)point;
- (CGPoint)pointValue;

@end
