//
//  STQuartzUtilities.h
//  Kahuna
//
//  Created by Davyd Geyl on 10/01/11.
//  Copyright 2011 Sportstec Ltd. All rights reserved.
//

#import <QuartzCore/QuartzCore.h>
#import <AppKit/AppKit.h>

extern size_t const STColorDepth;
extern size_t const STBitsPerComponent;

@interface STQuartzUtilities : NSObject

// creates bitmap image representation calling drawing selector of the object with optional parameter and last argument of the signature it always pass the bitmap context
+ (CGImageRef)newCGImageWithSize:(CGSize)imageSize object:(id)object selector:(SEL)selector parameter:(id)parameter flipped:(BOOL)flipped;
+ (CGImageRef)newCGImageWithSize:(CGSize)imageSize object:(id)object selector:(SEL)selector flipped:(BOOL)flipped;
+ (CGImageRef)newCGImageWithSize:(CGSize)imageSize object:(id)object selector:(SEL)selector parameter:(id)parameter;
+ (CGImageRef)newCGImageWithSize:(CGSize)imageSize object:(id)object selector:(SEL)selector;
+ (CGImageRef)newCGImageFromPNGData:(NSData*)imageData;

+ (CGImageRef)newCGImageWithSize:(CGSize)imageSize layer:(CALayer*)layer selector:(SEL)selector;

@end

// Convenience functions

CGColorSpaceRef STsRGBColorSpace(void);
CGImageRef STCreateCGImageFromFile(NSString* path);
CGImageRef STGetCGImageNamed(NSString* name);

NSData* STPNGDataWithContext(CGContextRef bitmapContext);
NSData* STPNGDataWithCGImageScale(CGImageRef image, CGFloat scale);
NSData* STPNGDataWithLayerImageSize(CALayer* layer, CGSize imageSize);

CGFloat STEvenRoundedNumber(CGFloat number);
CGPoint STEvenRoundedPoint(CGPoint point);

CGColorRef STCreatePatternColor(CGImageRef image);

NSData* STImageDataWithCGImage(CGImageRef image, const CFStringRef imageUTType);

CGImageRef STCreateImageWithLayer(CALayer* layer);
CGImageRef STCreateImageWithLayerFlipped(CALayer* layer, BOOL flip);
CGImageRef STCreateLayerImageWithSize(CALayer* layer, CGSize imageSize);
CGImageRef STCreateFlippedLayerImageWithSize(CALayer* layer, CGSize imageSize);

CGColorRef STCGColorGetBlackColor(void);
CGColorRef STCGColorGetWhiteColor(void);
CGColorRef STCGColorCreateFromComponents(CGFloat const comps[]);
CGColorRef STCGColorCreateGrayColor(CGFloat component, CGFloat alpha);

CGImageRef STCreateImageWithLayer(CALayer* layer);
CGImageRef STCreateFlippedImageWithLayer(CALayer* layer);
CGImageRef STCreateFlippedImageWithSize(CGSize imageSize, CALayer* layer, BOOL flipped);

void STDisableLayerImplicitAnimation(CALayer* layer);

CGImageRef STCGImageCreateScaledWithCGImage(CGImageRef image, CGFloat scale);
CGImageRef STCGImageCreateThumbnailWithCGImage(CGImageRef image, CGFloat thumbnailWidth);
