//
//  STXMLContext.h
//  Coda
//
//  Created by Davyd Geyl on 26/02/10.
//  Copyright 2010 Sportstec Ltd. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@protocol STXMLCoding;

@interface STXMLContext : NSObject

@property (nonatomic, copy) NSMutableString* stringContext;

+ (instancetype)context;

- (void)openTagForKey:(NSString*)key endRow:(BOOL)endRow;
- (void)openTagForKey:(NSString*)key; // ends the row
- (void)closeTagForKey:(NSString*)key;
- (void)appendSingleRowValue:(NSString*)value forKey:(NSString*)key;

@end

@protocol STXMLCoding

- (void)encodeWithXMLCodingContext:(STXMLContext*)context;
- (instancetype)initWithXMLCodingContext:(STXMLContext*)context;

@end

@interface NSString (XMLContent)

+ (NSString*)stringPreparedForXMLWithString:(NSString*)string;

@end

