//
//  STTimelineChangeLog.h
//  SCNFrameworks
//
//  Created by Yixiang Zhang on 27/4/17.
//  Copyright © 2017 Martin Redington. All rights reserved.
//

#import <Foundation/Foundation.h>

@class STTimelineChangeOperation;

@interface STTimelineChangeLog : NSObject

@property (nonatomic, readonly, nonnull) NSArray <STTimelineChangeOperation *> *operations;
@property (readonly) NSUInteger length;
@property (nonatomic, readonly, nullable) STTimelineChangeOperation *firstOperation;

@property (nonatomic, readonly, nullable) NSString *JSONStringRepresentation;
- (nullable instancetype)initWithJSON:(nonnull NSString *)JSONRepresentation;
- (nonnull NSString *)changeLogInTextSinceLastSyncTime;

- (void)addOperation:(nonnull STTimelineChangeOperation *)operation;

/**
 * This function will delete operations prior to the timeStamp and return them to the caller 
 *
 * @param timeStamp The time when all operations prior to that time will be deleted.
 *
 * @return An instance of STTimelineChangeLog with the changelogs that has been deleted.
 *  Will be an empty changelog if nothing meeting the criteria
 */
- (nonnull STTimelineChangeLog *)getAndDeleteOperationsBeforeTimeStamp:(NSTimeInterval)timeStamp;

@end

